/*
   This file is copyright (c) 1986, 1987 by William Couture.  All rights reserved.

   This version of DOSFNS uses AZTEC specific branch instructions!
*/
#include <compiler.h>
#include <regstruc.h>
#include <vim.h>
#define TRUE 1
#define FALSE 0


extern union regunion regs;
extern int mod,reg;
extern unsigned int whereptr,maxpara,segoffset,rom_offset;
extern unsigned int fileinput;
extern unsigned int outfile;
extern unsigned int doserrnum;

extern unsigned char mdaregs[NUM_CRT_REG];  /* 40 */
extern unsigned char mdaports[8];
extern unsigned char cgaregs[NUM_CRT_REG];  /* 40 */
extern unsigned char cgaports[6];
extern unsigned char egaports[28];
extern unsigned char siregs[NUM_SI_REG];  /* 20 */
extern unsigned char seqregs[NUM_SEQ_REG];  /* 10 */
extern unsigned char attribregs[NUM_ATTRIB_REG];  /* 50 */
extern unsigned int attribflipflop;
extern unsigned char vga_virt_dac[768];

extern unsigned char screen[12290];
extern unsigned char imagename[150];
extern unsigned char globalstr[150];
extern unsigned char nl_str[2];

unsigned int openfunction,readwrite,handle,totalpara;

void doserror();

void rwimg(byte)   /* read and write image of virtual machine */
   char byte;
   {
   doserrnum = 0;  /* start off with no error */
   if (imagename[0])
      {
      if (byte == 'W')
         {
         openfunction = 0x3c;  /* create */
         readwrite = 0x40;  /* write */
         }
      else
         {
         openfunction = 0x3d;  /* open */
         readwrite = 0x3f;  /* read */
         }
#asm
   mov dx,offset imagename_  ;filename to create
   mov cx,0                  ;attributes are 0 (nothing special)
   mov al,0                  ;mode is 0 (read only)
   mov ah,byte ptr openfunction_ ;the create function
   int 21h                   ;call DOS
   mov word ptr handle_,ax       ;save handle in a convenient variable
   blo err1                 ;jump on carry
   mov bx,ax                 ;and handle to BX for next DOS call
   mov dx,offset mdaregs_    ;write the monochrome regs
   mov cx,40                 ;40 bytes worth
   mov ah,byte ptr readwrite_    ;function = write
   int 21h                   ;call DOS
   blo err2                 ;jump on carry
   mov dx,offset mdaports_   ;write the monochrome ports
   mov bx,word ptr handle_       ;get the file handle
   mov cx,8                  ;8 bytes
   mov ah,byte ptr readwrite_    ;write
   int 21h                   ;call DOS
   blo err2                 ;jump on carry
   mov dx,offset cgaregs_    ;write the CGA regs
   mov bx,word ptr handle_       ;file handle
   mov cx,40                 ;40 bytes
   mov ah,byte ptr readwrite_    ;write
   int 21h                   ;call DOS
   blo err2                 ;jump on carry
   mov dx,offset cgaports_   ;write the CGA ports
   mov bx,word ptr handle_       ;file handle
   mov cx,6                  ;6 bytes
   mov ah,byte ptr readwrite_    ;write
   int 21h                   ;call DOS
   blo err2                 ;jump on carry
   mov dx,offset egaports_   ;the EGA ports
   mov bx,word ptr handle_       ;file handle
   mov cx,28                  ;28 bytes
   mov ah,byte ptr readwrite_    ;write
   int 21h                   ;call DOS
   blo err2                 ;jump on carry
   mov dx,offset siregs_     ;the SI registers
   mov bx,word ptr handle_       ;file handle
   mov cx,20                 ;20 bytes
   mov ah,byte ptr readwrite_    ;write
   int 21h                   ;call DOS
   blo err2                 ;jump on carry
   mov dx,offset seqregs_    ;the sequencer registers
   mov bx,word ptr handle_       ;file handle
   mov cx,10                 ;10 bytes
   mov ah,byte ptr readwrite_    ;write
   int 21h                   ;call DOS
   blo err2                 ;jump on carry
   mov dx,offset attribregs_ ;the attribute registers
   mov bx,word ptr handle_       ;file handle
   mov cx,50                 ;50 bytes
   mov ah,byte ptr readwrite_    ;write
   int 21h                   ;call DOS
   blo err2                 ;jump on carry
   mov dx,offset attribflipflop_   ;the flip-flop
   mov bx,word ptr handle_       ;file handle
   mov cx,2                  ;2 byte interger
   mov ah,byte ptr readwrite_    ;write
   int 21h                   ;call DOS
   blo err2                 ;jump on carry
   mov dx,offset vga_virt_dac_ ;the VGA virtual screen info
   mov bx,word ptr handle_  ;the handle
   mov cx,768              ;length of virtual info
   mov ah,byte ptr readwrite_  ;write
   int 21h                   ;call DOS
   blo err2                  ;jump on carry
   mov dx,offset regs_       ;write the registers
   mov cx,1ch                ;length is 28 bytes
   mov bx,word ptr handle_       ;file handle
   mov ah,byte ptr readwrite_    ;write
   int 21h                   ;call DOS
   blo err2                 ;jump on carry
   mov dx,offset screen_     ;write virtual screen
   mov cx,4096               ;4K
   mov bx,word ptr handle_       ;handle
   mov ah,byte ptr readwrite_    ;write
   int 21h                   ;call DOS
   blo err2                  ;jump on carry
   mov word ptr totalpara_,0     ;sum of paragraphs written
   mov ax,word ptr rom_offset_   ;get offset for replacement ROM
   add ax,word ptr segoffset_    ;add offset of virtual segment
   mov ds,ax                 ;set up for write of virtual memory
label01:
   push ds                   ;save current write segment
   mov dx,0                  ;write from offset 0
   mov cx,32768              ;32K
   mov bx,word ptr ss:handle_    ;handle
   mov ah,byte ptr ss:readwrite_ ;write
   int 21h                   ;call DOS
   pop bx                    ;get old segment
   blo err2                  ;jump on carry
   or ax,ax                  ;anything read?
   jz end_noerr              ;EOF, we're done
   mov cx,ax                 ;get count
   mov ax,1                  ;set up for error 1
   cmp cx,32768              ;was 32K read/written?
   jne err2                  ;no, report an error
   add bx,0800h              ;add 32K offset
   mov ds,bx                 ;new write segment
   mov dx,0                  ;still offset 0
   mov cx,32768              ;32K
   mov bx,word ptr ss:handle_    ;handle
   mov ah,byte ptr ss:readwrite_ ;write
   push ds                   ;save current write segment
   int 21h                   ;call DOS
   pop bx                    ;get old segment
   jnae err2                 ;jump on carry
   mov cx,ax                 ;save number of bytes read/written
   mov ax,1                  ;set up for error code 1
   cmp cx,32768              ;was 32K read/written?
   jne err2                  ;no, go do an error
   add bx,0800h              ;add 32K offset
   mov ds,bx                 ;set new write segment
   add word ptr ss:totalpara_,1000h ;add 64K in paragraphs to sum
   mov ax,word ptr ss:totalpara_    ;get total
   cmp ax,word ptr ss:maxpara_   ;all written?
   jne label01               ;nope, get more
   mov bx,word ptr ss:handle_  ;get handle
   xor cx,cx                  ;get a 0
   mov dx,cx                  ;both words
   mov ax,4201h               ;lseek to current + cx:dx
   int 21h                    ;call DOS
   mov si,dx                  ;save high word
   mov di,ax                  ;and low word of current loc
   xor cx,cx                  ;get a 0
   mov dx,cx                  ;both words
   mov ax,4202h               ;lseek to EOF + cx:dx
   int 21h                    ;call DOS
   mov cx,ax                  ;copy low word to cx
   mov ax,0f0h                ;set up for error
   cmp si,dx                  ;high words the same?
   jne err1                   ;no, trouble
   cmp di,cx                  ;low words the same?
   jne err1                   ;no, trouble
end_noerr:
   mov ax,ss                 ;move SS
   mov ds,ax                 ;to DS (I think this is DeSmet specific)
   mov bx,word ptr handle_       ;handle one last time
   mov ah,3eh                ;to close the file
   int 21h                   ;call DOS
   jmp endit                 ;and quit
err1:
   mov byte ptr readwrite_,3fh   ;force read/write to read, do not delete file
err2:
   mov cx,ss                 ;insure that DS = SS
   mov ds,cx
   mov word ptr doserrnum_,ax    ;save error code
   mov bx,word ptr handle_       ;get handle
   mov ah,3eh                ;try to close it
   int 21h                   ;call DOS
   cmp byte ptr readwrite_,40h   ;is this on a write?
   jne endit                 ;no, quit
   mov dx,offset imagename_  ;otherwise, try to delete the bad image
   mov ah,41h                ;delete function
   int 21h                   ;call DOS
endit:
#endasm
      if (doserrnum)  /* if error code */
         doserror(byte);
      else
         PUTS("OK.\n");
      }
   else
      PUTS("No image name.\n");
   }

void redirectinput(str,printerr)
   char *str;
   int printerr;
   {
   doserrnum = 0;  /* start off with no error */
   if (str[0] == '\0')
      strcpy(str,"CON");  /* force console input */
   strupr(str);  /* force upper case */
#asm
   mov bx,word ptr fileinput_          ;get the handle
   cmp bx,0                        ;null handle?
   je  inputnoclose                ;if so, do not close it
   mov ah,3eh                      ;close it
   int 21h                         ;call DOS
inputnoclose:
#endasm
   if (strcmp(str,"CON"))
      {
#asm
   mov dx,word ptr [bp+4]              ;get pointer to string
   mov ax,3d02h                    ;open file for read/write
   int 21h                         ;call DOS
   jnae rdinperr                   ;carry, time to abort
   mov word ptr fileinput_,ax          ;save the error code
   jmp endrdinp                    ;and quit
rdinperr:
   mov word ptr doserrnum_,ax          ;save the error code
   mov word ptr fileinput_,0           ;and set input file to null
endrdinp:
#endasm
      }
   else
      fileinput = 0;
   if ((doserrnum) && (printerr))
      doserror('r');
   }

void redirectoutput(str,printerr)
   char *str;
   int printerr;
   {
   doserrnum = 0;  /* start off with no error */
   if (str[0] == '\0')
      strcpy(str,"CON");
   strupr(str);  /* force upper case */
#asm
   mov bx,word ptr outfile_            ;get the handle
   cmp bx,0                        ;null handle?
   je  outputnoclose               ;if so, do not close it
   mov ah,3eh                      ;close it
   int 21h                         ;call DOS
outputnoclose:
#endasm
   if (strcmp(str,"CON"))
      {
#asm
   mov dx,word ptr [bp+4]              ;get pointer to string
   mov ax,3d02h                    ;fn = open, mode = read/write
   int 21h                         ;call DOS
   jae seek_to_end                 ;JNC seek_to_end
   cmp ax,2                        ;error = file not found?
   jne rdouterr                    ;no, skip to error ending
   mov cx,0                        ;normal attributes
   mov ah,3ch                      ;open file for read/write
   int 21h                         ;call DOS
   jnae rdouterr                   ;carry, time to abort
seek_to_end:
   mov word ptr outfile_,ax            ;save the file handle
   mov bx,ax                       ;bx = handle
   xor cx,cx                       ;cx = high word of seek loc = 0
   mov dx,cx                       ;cx:dx = seek loc = 0
   mov ax,4202h                    ;seek to EOF+cx:dx
   int 21h                         ;call DOS
   jmp endrdout                    ;and quit
rdouterr:
   mov word ptr doserrnum_,ax          ;save the error code
   mov word ptr outfile_,0             ;and say null output
endrdout:
#endasm
      }
   else
      outfile = 0;
   if ((doserrnum) && (printerr))
      doserror('W');
   }

void doserror(byte)
   char byte;
   {
   PUTS("Error: ");
   switch(doserrnum)
      {
      case 1:
         if (byte == 'W')
            PUTS("Disk full.");
         else
            PUTS("Read past end of file.");
         break;
      case 2:
         PUTS("File not found.");
         break;
      case 3:
         PUTS("Path not found.");
         break;
      case 4:
         PUTS("Too many open files.");
         break;
      case 5:
         PUTS("Access denied.");
         break;
      case 0xf0:
         PUTS("Image too big for memory.");
         break;
      default:
         PUTS("DOS internal error.  Code=");
         PUTS(hexword(&doserrnum,globalstr));
         break;
      }
   PUTS(nl_str);
   doserrnum = 0;  /* clear out error message */
   }

void new_rom()
   {
   readwrite = 0;  /* use as an error return */
#asm
   mov dx,offset globalstr_   ;filename to open
   mov ax,3d00h               ;open in read mode
   int 21h                    ;call DOS
   jae nr_1                   ;open, go ahead
   inc word ptr readwrite_        ;signal error
   jmp nr_done_1              ;and done
nr_1:
   mov word ptr handle_,ax        ;save handle
   mov bx,ax                  ;and set up for immediate use
   push ds                    ;save our ds
   mov ax,word ptr rom_offset_    ;get the ROM offset
   add ax,word ptr segoffset_     ;add the segment offset
   mov ds,ax                  ;this is where the new ROM goes
   xor dx,dx                  ;DS:DX = transfer address
   mov cx,32768               ;get 32K
   mov ah,3fh                 ;fn = read file
   int 21h                    ;call DOS
   pop ds                     ;restore our DS
   jnae nr_oops_2             ;can't read, error
   cmp ax,32768               ;all bytes read?
   jne nr_done                ;no, do not keep reading
   mov bx,word ptr handle_        ;get the file hanele back
   push ds                    ;save our ds
   mov ax,word ptr rom_offset_    ;get the ROM offset
   add ax,word ptr segoffset_     ;add the segment offset
   mov ds,ax                  ;this is where the new ROM goes
   mov dx,32768               ;DS:DX = just after previous address
   mov cx,dx                  ;again, want 32K
   mov ah,3fh                 ;fn = read file
   int 21h                    ;call DOS
   pop ds                     ;restore our ds
   jae nr_done                ;no carry, all done
nr_oops_2:
   add word ptr readwrite_,2      ;add 2 to error code
nr_done:
   mov bx,word ptr handle_        ;get the handle again
   mov ah,3eh                 ;fn = close file
   int 21h                    ;call DOS
nr_done_1:
#endasm
   if (readwrite)  /* if an error occurred */
      {
      switch (readwrite)
         {
         case 1:
            oops("ROM file not found.\n");
            break;
         case 2:
            oops("Error reading ROM file.\n");
            break;
         }
      }
   else
      rom_offset += 0x1000;
   }

void read_sects(seg,ofs,drive,sector,num)
             /* +4   +6   +8   +10   +12 */
   unsigned int seg,ofs,drive,sector,num;
   {
   unsigned char buf[1024];
              /* so it's larger than the 512 I say in the manual.  Sue me! */
   unsigned int i,seg2,ofs2;

   while (num--)
      {
      i = TRUE;  /* default to OK */
#asm
   mov dx,word ptr [bp+10]     ;get sector
   mov cx,1                ;1 sector at a time
   lea bx,word ptr [bp-1024]    ;offset of transfer
   mov al,byte ptr [bp+8]      ;drive
   push bp                 ;save bp
   int 25h                 ;read disk
   pop ax                  ;clean up stack
   pop bp                  ;restore bp
   jae read_sects_ok       ;if ok, skip this
   mov word ptr [bp-1026],0     ;else set flag to false
read_sects_ok:
#endasm
      if (i)
         {
         for (i = 0; i < 512; i++)
            putbyte(seg,ofs+i,buf[i]);
         ofs += 512;
         sector++;  /* get next sector next time */
         }
      else
         {
         PUTS("Error reading disk sector ");
         PUTS(hexword(&sector,globalstr));
         PUTS(nl_str);
         return;
         }
      }
   }

void write_sects(seg,ofs,drive,sector,num)
              /* +4   +6   +8   +10   +12 */
   unsigned int seg,ofs,drive,sector,num;
   {
   unsigned char buf[512];
   unsigned int i,seg2,ofs2;

   while (num--)
      {
      for (i = 0; i < 512; i++)
         buf[i] = fetchbyte(seg,ofs+i);
      ofs += 512;
      i = FALSE;  /* default to OK */
#asm
   mov dx,word ptr [bp+10]     ;get sector
   mov cx,1                ;1 sector at a time
   lea bx,word ptr [bp-512]    ;offset of transfer
   mov al,byte ptr [bp+8]      ;drive
   push bp                 ;save bp
   int 26h                 ;read disk
   pop ax                  ;clean up stack
   pop bp                  ;restore bp
   jae write_sects_ok      ;if ok, skip this
   mov word ptr [bp-514],1     ;else set flag to not ok
write_sects_ok:
#endasm
      if (i)
         {
         PUTS("Error writing disk sector ");
         PUTS(hexword(&sector,globalstr));
         PUTS(nl_str);
         return;
         }
      sector++;  /* write next sector next time */
      }
   }
