codeseg segment para public 'code'
dataseg segment para public 'data'
	extrn	clockcount_:word
	extrn	clockdivide_:word
	extrn	hwintflag_:word
	extrn	hwintstack_:word
	extrn	rshiftstatus_:word
	extrn	rshiftused_:word
	extrn	lshiftstatus_:word
	extrn	lshiftused_:word
	extrn	keybreak_:word
	extrn	keybdoff_:word
	extrn	hkscancode_:word
	extrn	hotkeypressed_:word
	extrn	port60ptr_:word
	extrn	port60queue_:word
	extrn	fake_retrace_:word
	extrn	retr_count_:word
	extrn	retr_num_:word
	extrn	retr_flag_:word
	extrn	videobase_:word
	extrn	port64hold_:word
	extrn	egascreen_:word
	extrn	int8ptr_:word
	extrn	int9ptr_:word
dataseg ends
	assume cs:codeseg,ds:nothing,es:nothing,ss:nothing
	extrn $begin:near
dsvalue	dw	dataseg



   public int8hdlr_
int8hdlr_ proc near
   cli                ;give us an interrupt free moment
   push ds            ;save whatever DS was passed us
   push ax            ;save work register AX
;   mov ax,0b800h
;   mov ds,ax
;   inc byte [0]
   mov ax,40h         ;set ax to 40h
   mov ds,ax          ;ds to 40h
   mov byte ptr [40h],255 ;move 255 to the byte at 40:40 (abs 440) so that the
                      ;decrement at the clock tick will NOT turn off the
                      ;floppy motor.  This allows VIM, doing BIOS calls, to
                      ;finish what it is doing before the real BIOS turns
                      ;off the disk drive
   mov  ds,word ptr cs:[dsvalue] ;get the program's DS, saved at program start
	assume ds:dataseg
 INC WORD ptr clockcount_
 MOV AX,WORD ptr clockcount_
 CMP AX,WORD ptr clockdivide_
 JBE _L1
 MOV WORD ptr hwintflag_,1
 MOV WORD ptr hwintstack_,8
 MOV WORD ptr clockcount_,0
_L1:
   cmp word ptr fake_retrace_,1 ;are we doing a fake retrace?
   jne clock_int_1         ;no, skip this
   dec byte ptr retr_count_    ;count this tick
   jnz clock_int_1         ;not zero, not time to change yet
   mov ax,word ptr retr_num_   ;get length of retrace
   mov word ptr retr_count_,ax ;reset counter
   xor byte ptr retr_flag_,1   ;toggle TRUE/FALSE
clock_int_1:
   pop ax                 ;restore work register
   pushf                 ;save flags to simulate an int
   call dword ptr [int8ptr_]    ;far (long) call to old int routine
                         ;Note that old routine MUST be CALLed, so it can
                         ;return here to
   pop ds                ;restore DS to it state at routine entry
	assume	ds:nothing
   iret                  ;return to calling routine
int8hdlr_ endp


   public int9hdlr_
int9hdlr_ proc near
   cli                ;give us an interrupt free moment
   push ds            ;save whatever DS was passed us
   mov  ds,word ptr cs:[dsvalue] ;get the program's DS, saved at program start
	assume ds:dataseg
   push si            ;si is used by the following C code
   push ax                  ;save ax register
   in al,64h                ;get the AT keyboard status register
   mov byte ptr port64hold_,al  ;save for later
   in  al,60h               ;get scancode
   mov ah,al                ;copy into ah for processing
   or ah,byte ptr keybreak_     ;new keyboard encoding break flag
   cmp ah,36h               ;right shift pressed?
   jne checknotshift        ;no, skip this
   mov byte ptr rshiftstatus_,1 ;set shift status for hotkey
   jmp checkforhotkey       ;go see if this is the hotkey
checknotshift:
   cmp ah,0b6h              ;right shift released?
   jne checkleftshift       ;no, skip clearing flag
   mov byte ptr rshiftstatus_,0 ;clear shift status for hotkey
   mov byte ptr rshiftused_,0   ;signal this shift as not used
   jmp checkforhotkey       ;and see about other stuff
checkleftshift:
   cmp ah,2ah               ;left shift pressed?
   jne checknotleft         ;no, skip this
   mov byte ptr lshiftstatus_,1 ;set left shift status for hotkey
   jmp checkforhotkey       ;and see about hotkey
checknotleft:
   cmp ah,0aah              ;left shift released?
   jne checkforhotkey       ;no, skip clearing flag
   mov byte ptr lshiftstatus_,0 ;clear shift status for hotkey
   mov byte ptr lshiftused_,0   ;signal this shift as not used
checkforhotkey:
   cmp ah,byte ptr hkscancode_  ;is this the "hot key"?
   jne saveport60           ;no, process as normal
   cmp byte ptr rshiftstatus_,1 ;is right shift pressed?
   jne isitleft             ;no, check on left shift
   mov byte ptr hotkeypressed_,1 ;flag interrupt to VIM
   jmp doint9now            ;do not pass hotkey to simulator
isitleft:
   cmp byte ptr lshiftstatus_,1 ;is left shift pressed?
   jne saveport60           ;no, process as normal
   mov byte ptr hotkeypressed_,2 ;flag interrupt to VIM
   jmp doint9now            ;do not pass hotkey to simulator
saveport60:
   cmp byte ptr keybdoff_,1     ;is keyboard off?
   je doint9now             ;yes, screw this
   mov si,word ptr port60ptr_   ;get pointer into keyboard port
   cmp si,60                ;queue full?
   jae doint9now            ;yes, skip processing
   add si,offset port60queue_  ;add array base
   cmp ah,36h               ;right shift pressed? (again)
   je  doint9now            ;yes, do not save it yet
   cmp ah,2ah               ;left shift pressed? (again)
   je  doint9now            ;yes, do not save it yet
   cmp byte ptr rshiftstatus_,1 ;right shift pressed?
   jne saveleft             ;no, skip this
   cmp byte ptr rshiftused_,1   ;has the shift been recorded?
   je  saveleft             ;yes, skip this
   mov byte ptr [si],36h        ;move a right shift into the queue before the
                            ;current character
   inc si                   ;update si for next keypress into buffer
   inc word ptr port60ptr_      ;update pointer into port60queue
   mov byte ptr rshiftused_,1   ;flag this shift as USED
   jmp moresavep60          ;and save the keypress
saveleft:
   cmp byte ptr lshiftstatus_,1 ;left shift pressed?
   jne moresavep60          ;no, skip it
   cmp byte ptr lshiftused_,1   ;has the shift been recorded?
   je  moresavep60          ;yes, skip this
   mov byte ptr [si],2ah        ;move a left shift into the queue before the
                            ;current character
   inc si                   ;update si for next keypress into buffer
   inc word ptr port60ptr_      ;update pointer into port60queue
   mov byte ptr lshiftused_,1   ;and flag this shift as USED
moresavep60:
   mov byte ptr [si],al         ;save this keypress
   inc word ptr port60ptr_      ;and update pointer into port60queue
   mov word ptr hwintflag_,1    ;tell simulator of interrupt
   mov si,2                 ;9-HWINTBASE, *2 for word address
   add si,offset hwintstack_  ;add array base
   mov word ptr [si],9          ;say who is requesting interrupt
doint9now:
   mov byte ptr keybreak_,0     ;default to no breakcode
   cmp al,0f0h              ;is this the new break code?
   jne finish9              ;no, finish interrupt 9
   mov byte ptr keybreak_,80h   ;set flag for next pass
finish9:
   pop ax                   ;restore work register
   pop si                   ;restore index register
   pushf                    ;flags to stack to simulate an interrupt
   call dword ptr [int9ptr_]     ;far (long) call to old int routine
                            ;Note that old routine MUST be CALLed, so it can
                            ;return here to
   pop ds                   ;restore DS to it state at routine entry
	assume ds:nothing
   iret                     ;return to caller
int9hdlr_ endp


   public intahdlr_
intahdlr_ proc near
   cli                     ;give us an interrupt free moment
   push ds                 ;save whatever DS was passed us
   mov  ds,word ptr cs:[dsvalue] ;get the program's DS, saved at program start
	assume ds:dataseg
 MOV WORD ptr hwintflag_,1
 MOV WORD ptr hwintstack_[4],10
   pop ds                  ;restore DS to it state at routine entry
	assume	ds:nothing
   iret                  ;return to calling routine
intahdlr_ endp


   public intbhdlr_
intbhdlr_ proc near
   cli                     ;give us an interrupt free moment
   push ds                 ;save whatever DS was passed us
   mov  ds,word ptr cs:[dsvalue] ;get the program's DS, saved at program start
	assume ds:dataseg
 MOV WORD ptr hwintflag_,1
 MOV WORD ptr hwintstack_[6],11
   pop ds                  ;restore DS to it state at routine entry
	assume	ds:nothing
   iret                  ;return to calling routine
intbhdlr_ endp


   public intchdlr_
intchdlr_ proc near
   cli                     ;give us an interrupt free moment
   push ds                 ;save whatever DS was passed us
   mov  ds,word ptr cs:[dsvalue] ;get the program's DS, saved at program start
	assume ds:dataseg
 MOV WORD ptr hwintflag_,1
 MOV WORD ptr hwintstack_[8],12
   pop ds                  ;restore DS to it state at routine entry
	assume	ds:nothing
   iret                  ;return to calling routine
intchdlr_ endp


   public intdhdlr_
intdhdlr_ proc near
   cli                     ;give us an interrupt free moment
   push ds                 ;save whatever DS was passed us
   mov  ds,word ptr cs:[dsvalue] ;get the program's DS, saved at program start
	assume ds:dataseg
 MOV WORD ptr hwintflag_,1
 MOV WORD ptr hwintstack_[10],13
   pop ds                  ;restore DS to it state at routine entry
	assume	ds:nothing
   iret                  ;return to calling routine
intdhdlr_ endp


   public intehdlr_
intehdlr_ proc near
   cli                     ;give us an interrupt free moment
   push ds                 ;save whatever DS was passed us
   mov  ds,word ptr cs:[dsvalue] ;get the program's DS, saved at program start
	assume ds:dataseg
 MOV WORD ptr hwintflag_,1
 MOV WORD ptr hwintstack_[12],14
   pop ds                  ;restore DS to it state at routine entry
	assume	ds:nothing
   iret                  ;return to calling routine
intehdlr_ endp


   public intfhdlr_
intfhdlr_ proc near
   cli                     ;give us an interrupt free moment
   push ds                 ;save whatever DS was passed us
   mov  ds,word ptr cs:[dsvalue] ;get the program's DS, saved at program start
	assume ds:dataseg
 MOV WORD ptr hwintflag_,1
 MOV WORD ptr hwintstack_[14],15
   pop ds                  ;restore DS to it state at routine entry
	assume	ds:nothing
   iret                  ;return to calling routine
intfhdlr_ endp


   public int70hdlr_
int70hdlr_ proc near
   cli                     ;give us an interrupt free moment
   push ds                 ;save whatever DS was passed us
   mov  ds,word ptr cs:[dsvalue] ;get the program's DS, saved at program start
	assume ds:dataseg
 MOV WORD ptr hwintflag_,1
 MOV WORD ptr hwintstack_[16],112
   pop ds                  ;restore DS to it state at routine entry
	assume	ds:nothing
   iret                  ;return to calling routine
int70hdlr_ endp


   public int71hdlr_
int71hdlr_ proc near
   cli                     ;give us an interrupt free moment
   push ds                 ;save whatever DS was passed us
   mov  ds,word ptr cs:[dsvalue] ;get the program's DS, saved at program start
	assume ds:dataseg
 MOV WORD ptr hwintflag_,1
 MOV WORD ptr hwintstack_[18],113
   pop ds                  ;restore DS to it state at routine entry
	assume	ds:nothing
   iret                  ;return to calling routine
int71hdlr_ endp


   public int72hdlr_
int72hdlr_ proc near
   cli                     ;give us an interrupt free moment
   push ds                 ;save whatever DS was passed us
   mov  ds,word ptr cs:[dsvalue] ;get the program's DS, saved at program start
	assume ds:dataseg
 MOV WORD ptr hwintflag_,1
 MOV WORD ptr hwintstack_[20],114
   pop ds                  ;restore DS to it state at routine entry
	assume	ds:nothing
   iret                  ;return to calling routine
int72hdlr_ endp


   public int73hdlr_
int73hdlr_ proc near
   cli                     ;give us an interrupt free moment
   push ds                 ;save whatever DS was passed us
   mov  ds,word ptr cs:[dsvalue] ;get the program's DS, saved at program start
	assume ds:dataseg
 MOV WORD ptr hwintflag_,1
 MOV WORD ptr hwintstack_[22],115
   pop ds                  ;restore DS to it state at routine entry
	assume	ds:nothing
   iret                  ;return to calling routine
int73hdlr_ endp


   public int74hdlr_
int74hdlr_ proc near
   cli                     ;give us an interrupt free moment
   push ds                 ;save whatever DS was passed us
   mov  ds,word ptr cs:[dsvalue] ;get the program's DS, saved at program start
	assume ds:dataseg
 MOV WORD ptr hwintflag_,1
 MOV WORD ptr hwintstack_[24],116
   pop ds                  ;restore DS to it state at routine entry
	assume	ds:nothing
   iret                  ;return to calling routine
int74hdlr_ endp


   public int75hdlr_
int75hdlr_ proc near
   cli                     ;give us an interrupt free moment
   push ds                 ;save whatever DS was passed us
   mov  ds,word ptr cs:[dsvalue] ;get the program's DS, saved at program start
	assume ds:dataseg
 MOV WORD ptr hwintflag_,1
 MOV WORD ptr hwintstack_[26],117
   pop ds                  ;restore DS to it state at routine entry
	assume	ds:nothing
   iret                  ;return to calling routine
int75hdlr_ endp


   public int76hdlr_
int76hdlr_ proc near
   cli                     ;give us an interrupt free moment
   push ds                 ;save whatever DS was passed us
   mov  ds,word ptr cs:[dsvalue] ;get the program's DS, saved at program start
	assume ds:dataseg
 MOV WORD ptr hwintflag_,1
 MOV WORD ptr hwintstack_[28],118
   pop ds                  ;restore DS to it state at routine entry
	assume	ds:nothing
   iret                  ;return to calling routine
int76hdlr_ endp


   public int77hdlr_
int77hdlr_ proc near
   cli                     ;give us an interrupt free moment
   push ds                 ;save whatever DS was passed us
   mov  ds,word ptr cs:[dsvalue] ;get the program's DS, saved at program start
	assume ds:dataseg
 MOV WORD ptr hwintflag_,1
 MOV WORD ptr hwintstack_[30],119
   pop ds                  ;restore DS to it state at routine entry
	assume	ds:nothing
   iret                  ;return to calling routine
int77hdlr_ endp

   public ctrlchdlr_
ctrlchdlr_ proc near
   clc       ;continue program execution
   db 0cbh   ;RET FAR, not supported by ASM88
ctrlchdlr_ endp
